<?php
namespace FiloBlu\StockaFix\Helper;

/**
 * Class ReportHelper
 */
class ReportHelper
{
    /**
     * @var \Magento\Framework\App\ResourceConnection
     */
    protected $resourceConnection;

    /**
     * ReportHelper constructor.
     * @param \Magento\Framework\App\ResourceConnection $resourceConnection
     */
    public function __construct(
        \Magento\Framework\App\ResourceConnection $resourceConnection
    )
    {
        $this->resourceConnection= $resourceConnection;
    }

    /**
     * @param \FiloBlu\StockaFix\Model\Report $report
     * @return string
     * @throws \Exception
     */
    public function getReportSqlView(\FiloBlu\StockaFix\Model\Report $report)
    {
        if(!($id = $report->getId()))
        {
            throw new \Exception(__('Report has no id'));
        }

        return "filoblu_stockafix_view_{$id}";
    }

    /**
     * @param \FiloBlu\StockaFix\Model\Report $report
     * @param $removeReportId
     * @return array
     * @throws \Exception
     */
    public function getReportMeta(\FiloBlu\StockaFix\Model\Report $report , $removeReportId)
    {
        //TODO:  modify by select - \FiloBlu\StockaFix\Model\ResourceModel\ReportOutputCollection::_initInitialFieldsToSelect & \FiloBlu\StockaFix\Ui\Component\Listing\Columns::prepare
        $view = $this->getReportSqlView($report);
        $rawMeta = $this->resourceConnection->getConnection()->query("DESCRIBE `{$view}`")->fetchAll();

        $meta = [];
        foreach ($rawMeta as $info) {
            $meta[$info['Field']] = $info;
        }

        if ($removeReportId) {
            unset($meta['reportoutput_id']);
        }
        return $meta;
    }
}
